"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _child_process = require("child_process");

var _fs = require("fs");

var _path = require("path");

var pExec = function pExec(command) {
  return new Promise(function (resolve, reject) {
    // eslint-disable-next-line max-params
    (0, _child_process.exec)(command, function (error, stdout, stderr) {
      if (stderr) {
        console.error("stderr: ".concat(stderr));
      }

      if (error) {
        reject(error);
      }

      resolve(stdout);
    });
  });
};

var getAllFiles = function getAllFiles(dirPath) {
  var arrayOfFilesInput = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var files = (0, _fs.readdirSync)(dirPath);
  var arrayOfFiles = arrayOfFilesInput;
  files.forEach(function (file) {
    if ((0, _fs.statSync)(dirPath + '/' + file).isDirectory()) {
      arrayOfFiles = getAllFiles(dirPath + '/' + file, arrayOfFiles);
    } else {
      arrayOfFiles.push((0, _path.join)(dirPath, '/', file));
    }
  });
  return arrayOfFiles;
};

var TMP_FOLDER = '/tmp/serverless-esbuild-bundle-analyzer';

function bundleVisualizer() {
  return _bundleVisualizer.apply(this, arguments);
}

function _bundleVisualizer() {
  _bundleVisualizer = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var functionName, functionZipName, TEMP_DIR_LOCATION, test, metafileName;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            functionName = this.options.analyze;

            if (!(functionName === undefined)) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return");

          case 3:
            functionZipName = this.serverless.service.getAllFunctionsNames().find(function (fullFunctionName) {
              return fullFunctionName.endsWith(functionName);
            });

            if (!(functionZipName === undefined)) {
              _context.next = 7;
              break;
            }

            this.serverless.cli.log("\uD83E\uDD2F Analyze failed: function ".concat(functionName, " was not found"), 'ServerlessAnalyzeBundlePlugin', {
              color: 'red'
            });
            return _context.abrupt("return");

          case 7:
            this.serverless.cli.log("\u23F3 Analyzing function ".concat(functionName), 'ServerlessAnalyzeBundlePlugin');
            TEMP_DIR_LOCATION = "".concat(TMP_FOLDER, "/").concat(functionZipName, "/").concat(new Date().getTime());
            _context.next = 11;
            return pExec("mkdir -p ".concat(TEMP_DIR_LOCATION));

          case 11:
            _context.next = 13;
            return pExec("unzip .serverless/".concat(functionZipName, " -d ").concat(TEMP_DIR_LOCATION));

          case 13:
            test = getAllFiles("".concat(TEMP_DIR_LOCATION));
            metafileName = test.filter(function (fileName) {
              return fileName.includes("/".concat(functionName, "/")) && fileName.endsWith('-meta.json');
            })[0];
            _context.next = 17;
            return pExec(['node_modules/.bin/esbuild-visualizer', '--metadata', metafileName, '--filename', "".concat(TEMP_DIR_LOCATION, "/").concat(functionName, ".html"), '--open'].join(' '));

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _bundleVisualizer.apply(this, arguments);
}

var _default = bundleVisualizer;
exports["default"] = _default;
//# sourceMappingURL=bundleVisualizer.js.map